;// include file into MozMem_*.asm
;// DLL file header

%ifndef pe_ImageBase
;//pe_ImageBase equ 0FB50000
%define pe_ImageBase 0FB50000
%endif

%define PE_Header

;// start_Code, end_Code defined in main asm

pe_SizeOfCode equ 7000h
pe_SizeOfInitData equ 1000h
pe_SizeOfUninitData equ 0
pe_Entry equ 1000h
pe_Base equ 1000h
pe_DataBase equ pe_Base+pe_SizeOfCode
pe_SizeOfImage equ 0A000h
rva_Bss equ 8000h

rva_Exports equ 9000h
%ifdef Palemoon
size_Exports equ 600h
%else
size_Exports equ 200h
%endif
rva_Imports equ 0 ;//!!!todo
size_Imports equ 0 ;//!!!todo

code_OffsToRva equ 1000h - 400h

;// MZ header:
db 'MZ',50h,0, 2,0,0,0, 4,0,0Fh,0, 0FFh,0FFh,0,0
db 0B8h,0,0,0, 0,0,0,0, 40h,0,1Ah,0, 0,0,0,0
dd 0,0,0,0
dd 0,0,0,100h
;// 40
db 0BAh,10h,0,0Eh, 1Fh,0B4h,9,0CDh, 21h,0B8h,1,4Ch, 0CDh,21h,90h,90h
db 'This program mus'
db 't be run under W'
db 'in32',13,10,24h,37h, 0,0,0,0, 0,0,0,0
;// 80
dd 0,0,0,0
dd 0,0,0,0
dd 0,0,0,0
dd 0,0,0,0
dd 0,0,0,0
dd 0,0,0,0
dd 0,0,0,0
dd 0,0,0,0

dllTimeStamp equ 584D9800h

;// 100
num_Sections equ 3
db 'PE',0,0, 4Ch,1,num_Sections,0  ;// 00,98h,4Dh,58h, 0,0,0,0
dd dllTimeStamp, 0
;// A18E is Characteristics - need to remove .relocs?!
db 0,0,0,0, 0E0h,0,8Fh,0A1h, 0Bh,1,2,19h
dd pe_SizeOfCode
dd pe_SizeOfInitData, 0, pe_Entry, pe_Base
dd pe_DataBase, pe_ImageBase, 1000h, 200h
dw 1,0, 0,0, 4,0, 0,0
dd pe_SizeOfImage, 400h, 0
dw 2,1
;// 160
dd 0,0,100000h,1000h
dd 0,10h, rva_Exports, size_Exports
dd rva_Imports, size_Imports, 0,0  ;// no resources...
dd 0,0,0,0  ;// no Exception, no Security
;// 1A0
dd 0,0,0,0  ;// no Reloc, no Debug
dd 0,0,0,0  ;// no other garbage sections...
dd 0,0,0,0
dd 0,0,0,0
dd 0,0,0,0
dd 0,0
;// 1F8
db 'CODE',0,0,0,0
;// 200
dd pe_SizeOfCode,1000h, end_Code, 400h  ;// 3000h = end_Code-start_Code
dd 0,0,0,60000020h  ;// Characteristics includes reloc ?
;// 220
db 'BSS',0, 0,0,0,0
ptr_Bss equ end_Code + 400h;//3400h ;// must be at end of Code~Data segment even if has no data...
dd 1000h, rva_Bss, 0, ptr_Bss
dd 0,0,0,0C0000000h
;// 248
db '.edata',0,0
foffs_Exports equ (end_Code + 400h)
dd 1000h,rva_Exports,size_Exports,foffs_Exports
dd 0,0,0,50000040h ;// Characteristics ?
;// 270

align 400h, db 0
