;// MozMem exports section

;// assume already included sector-aligned
;//align 200h, db 0

Offs_Exports equ $
Rva_Exports  equ 9000h

;//error?! exp_ToRva equ (Rva_Exports - Offs_Exports)
;//??? exp_ToRva equ (9000h - (end_Code + 400h))
exp_ToRva equ Rva_Exports

;// dllTimeStamp defined in MozMem_dllHeader.inc

%ifdef Palemoon
%define Link_MOZGLUE
%define C_MEM_Handlers
%endif

%ifdef Link_MOZGLUE
%define C_MEM_Handlers
%endif ;Link_MOZGLUE

%ifdef Palemoon
  exp_FuncCount equ 27+5
%else
  %ifdef C_MEM_Handlers
    exp_FuncCount equ 7+5
  %else
    exp_FuncCount equ 5
  %endif
%endif
exp_NameCount equ exp_FuncCount

%ifndef PE_Header
  dllTimeStamp equ 584D9800h
  start_Code equ ($-$$)
  code_ToRva equ (1000h - 400h)
%endif ;!PE_Header

ExportDir:
  dd 0,dllTimeStamp,0
  dd (dllName - Offs_Exports) + exp_ToRva, 1
  dd exp_FuncCount, exp_NameCount
  dd (FuncTable - Offs_Exports) + exp_ToRva
  dd (NameTable - Offs_Exports) + exp_ToRva
  dd (OrdTable - Offs_Exports)  + exp_ToRva

FuncTable:
  dd (MmCreatePool -start_Code)+code_ToRva                     ; 0
  fi_MmCreatePool equ 0
  dd (MmAlloc -start_Code)+code_ToRva                          ; 1
  fi_MmAlloc equ 1
  dd (MmFree -start_Code)+code_ToRva                           ; 2
  fi_MmFree equ 2
  dd (MmReAlloc -start_Code)+code_ToRva                        ; 3
  fi_MmReAlloc equ 3
  dd (MmQuery -start_Code)+code_ToRva                          ; 4
  fi_MmQuery equ 4
  %ifdef C_MEM_Handlers
    dd (C_expand -start_Code)+code_ToRva                         ; 5
    fi__expand equ 5
    dd (C_query -start_Code)+code_ToRva                          ; 6 _msize
    fi__msize equ 6
    dd (C_reCalloc -start_Code)+code_ToRva                       ; 7
    fi__recalloc equ 7
    dd (C_calloc -start_Code)+code_ToRva                         ; 8
    fi_calloc equ 8
    dd (C_free -start_Code)+code_ToRva                           ; 9
    fi_free equ 9
    dd (C_malloc -start_Code)+code_ToRva                         ; 10
    fi_malloc equ 10
    dd (C_realloc -start_Code)+code_ToRva                        ; 11
    fi_realloc equ 11
    %ifdef Palemoon
      dd (for__aligned_free -Offs_Exports)+exp_ToRva               ; 12
      fi__aligned_free equ 12
      dd (for__aligned_malloc -Offs_Exports)+exp_ToRva             ; 13
      fi__aligned_malloc equ 13
      dd (for__aligned_msize -Offs_Exports)+exp_ToRva              ; 14
      fi__aligned_msize equ 14
      dd (for__aligned_offset_malloc -Offs_Exports)+exp_ToRva      ; 15
      fi__aligned_offset_malloc equ 15
      dd (for__aligned_offset_realloc -Offs_Exports)+exp_ToRva     ; 16
      fi__aligned_offset_realloc equ 16
      dd (for__aligned_offset_recalloc -Offs_Exports)+exp_ToRva    ; 17
      fi__aligned_offset_recalloc equ 17
      dd (for__aligned_realloc -Offs_Exports)+exp_ToRva            ; 18
      fi__aligned_realloc equ 18
      dd (for__aligned_recalloc -Offs_Exports)+exp_ToRva           ; 19
      fi__aligned_recalloc equ 19
      dd (for__callnewh -Offs_Exports)+exp_ToRva                   ; 20
      fi__callnewh equ 20
      dd (for__calloc_base -Offs_Exports)+exp_ToRva                ; 21
      fi__calloc_base equ 21
      dd (for__free_base -Offs_Exports)+exp_ToRva                  ; 22
      fi__free_base equ 22
      dd (for__get_heap_handle -Offs_Exports)+exp_ToRva            ; 23
      fi__get_heap_handle equ 23
      dd (for__heapchk -Offs_Exports)+exp_ToRva                    ; 24
      fi__heapchk equ 24
      dd (for__heapmin -Offs_Exports)+exp_ToRva                    ; 25
      fi__heapmin equ 25
      dd (for__heapwalk -Offs_Exports)+exp_ToRva                   ; 26
      fi__heapwalk equ 26
      dd (for__malloc_base -Offs_Exports)+exp_ToRva                ; 27
      fi__malloc_base equ 27
      dd (for__query_new_handler -Offs_Exports)+exp_ToRva          ; 28
      fi__query_new_handler equ 28
      dd (for__query_new_mode -Offs_Exports)+exp_ToRva             ; 29
      fi__query_new_mode equ 29
      dd (for__realloc_base -Offs_Exports)+exp_ToRva               ; 30
      fi__realloc_base equ 30
      dd (for__set_new_mode -Offs_Exports)+exp_ToRva               ; 31
      fi__set_new_mode equ 31
    %endif ;Palemoon
  %endif ;C_MEM_Handlers

NameTable:
  %ifdef C_MEM_Handlers
    %ifdef Palemoon
      dd (name__aligned_free -Offs_Exports)+exp_ToRva
      dd (name__aligned_malloc -Offs_Exports)+exp_ToRva
      dd (name__aligned_msize -Offs_Exports)+exp_ToRva
      dd (name__aligned_offset_malloc -Offs_Exports)+exp_ToRva
      dd (name__aligned_offset_realloc -Offs_Exports)+exp_ToRva
      dd (name__aligned_offset_recalloc -Offs_Exports)+exp_ToRva
      dd (name__aligned_realloc -Offs_Exports)+exp_ToRva
      dd (name__aligned_recalloc -Offs_Exports)+exp_ToRva
      dd (name__callnewh -Offs_Exports)+exp_ToRva
      dd (name__calloc_base -Offs_Exports)+exp_ToRva
    %endif
    dd (name__expand -Offs_Exports)+exp_ToRva
    %ifdef Palemoon
      dd (name__free_base -Offs_Exports)+exp_ToRva
      dd (name__get_heap_handle -Offs_Exports)+exp_ToRva
      dd (name__heapchk -Offs_Exports)+exp_ToRva
      dd (name__heapmin -Offs_Exports)+exp_ToRva
      dd (name__heapwalk -Offs_Exports)+exp_ToRva
      dd (name__malloc_base -Offs_Exports)+exp_ToRva
    %endif
    dd (name__msize -Offs_Exports)+exp_ToRva
    %ifdef Palemoon
      dd (name__query_new_handler -Offs_Exports)+exp_ToRva
      dd (name__query_new_mode -Offs_Exports)+exp_ToRva
      dd (name__realloc_base -Offs_Exports)+exp_ToRva
    %endif
    dd (name__recalloc -Offs_Exports)+exp_ToRva
    %ifdef Palemoon
      dd (name__set_new_mode -Offs_Exports)+exp_ToRva
    %endif
  %endif
  dd (name_MmAlloc -Offs_Exports)+exp_ToRva
  dd (name_MmCreatePool -Offs_Exports)+exp_ToRva
  dd (name_MmFree -Offs_Exports)+exp_ToRva
  dd (name_MmQuery -Offs_Exports)+exp_ToRva
  dd (name_MmReAlloc -Offs_Exports)+exp_ToRva
  %ifdef C_MEM_Handlers
    dd (name_calloc -Offs_Exports)+exp_ToRva
    dd (name_free -Offs_Exports)+exp_ToRva
    dd (name_malloc -Offs_Exports)+exp_ToRva
    dd (name_realloc -Offs_Exports)+exp_ToRva
  %endif

OrdTable:
  %ifdef C_MEM_Handlers
    %ifdef Palemoon
      dw fi__aligned_free
      dw fi__aligned_malloc
      dw fi__aligned_msize
      dw fi__aligned_offset_malloc
      dw fi__aligned_offset_realloc
      dw fi__aligned_offset_recalloc
      dw fi__aligned_realloc
      dw fi__aligned_recalloc
      dw fi__callnewh
      dw fi__calloc_base
    %endif
    dw fi__expand
    %ifdef Palemoon
      dw fi__free_base
      dw fi__get_heap_handle
      dw fi__heapchk
      dw fi__heapmin
      dw fi__heapwalk
      dw fi__malloc_base
    %endif
    dw fi__msize
    %ifdef Palemoon
      dw fi__query_new_handler
      dw fi__query_new_mode
      dw fi__realloc_base
    %endif
    dw fi__recalloc
    %ifdef Palemoon
      dw fi__set_new_mode
    %endif
  %endif
  dw fi_MmAlloc
  dw fi_MmCreatePool
  dw fi_MmFree
  dw fi_MmQuery
  dw fi_MmReAlloc
  %ifdef C_MEM_Handlers
    dw fi_calloc
    dw fi_free
    dw fi_malloc
    dw fi_realloc
  %endif

;// macro cannot be defined in included file ?!
;// %macro expForward 2
;//   name_%1: db "%1",0
;//   for_%1: db %2,0
;// %endmacro
;// %macro expName 1
;//   name_%1: db '%1',0
;// %endmacro

;// simulate api-ms-win-crt-heap-l1-1-0.dll
;// mozglue.dll uses only malloc,free from this dll

%ifdef Palemoon
dllName: db 'api-ms-win-crt-heap-l1-1-0.dll',0
%else
dllName: db 'MozMem.dll',0
%endif

%ifdef Palemoon
name__aligned_free: db '_aligned_free',0
for__aligned_free: db 'ucrtbase._aligned_free',0

name__aligned_malloc: db '_aligned_malloc',0
for__aligned_malloc: db 'ucrtbase._aligned_malloc',0

name__aligned_msize: db '_aligned_msize',0
for__aligned_msize: db 'ucrtbase._aligned_msize',0

name__aligned_offset_malloc: db '_aligned_offset_malloc',0
for__aligned_offset_malloc: db 'ucrtbase._aligned_offset_malloc',0

name__aligned_offset_realloc: db '_aligned_offset_realloc',0
for__aligned_offset_realloc: db 'ucrtbase._aligned_offset_realloc',0

name__aligned_offset_recalloc: db '_aligned_offset_recalloc',0
for__aligned_offset_recalloc: db 'ucrtbase._aligned_offset_recalloc',0

name__aligned_realloc: db '_aligned_realloc',0
for__aligned_realloc: db 'ucrtbase._aligned_realloc',0

name__aligned_recalloc: db '_aligned_recalloc',0
for__aligned_recalloc: db 'ucrtbase._aligned_recalloc',0

name__callnewh: db '_callnewh',0
for__callnewh: db 'ucrtbase._callnewh',0

name__calloc_base: db '_calloc_base',0
for__calloc_base: db 'ucrtbase._calloc_base',0

;// expForward _expand 'ucrtbase._expand'

name__free_base: db '_free_base',0
for__free_base: db 'ucrtbase._free_base',0

name__get_heap_handle: db '_get_heap_handle',0
for__get_heap_handle: db 'ucrtbase._get_heap_handle',0

name__heapchk: db '_heapchk',0
for__heapchk: db 'ucrtbase._heapchk',0

name__heapmin: db '_heapmin',0
for__heapmin: db 'ucrtbase._heapmin',0

name__heapwalk: db '_heapwalk',0
for__heapwalk: db 'ucrtbase._heapwalk',0

name__malloc_base: db '_malloc_base',0
for__malloc_base: db 'ucrtbase._malloc_base',0

;// expForward _msize 'ucrtbase._msize'

name__query_new_handler: db '_query_new_handler',0
for__query_new_handler: db 'ucrtbase._query_new_handler',0

name__query_new_mode: db '_query_new_mode',0
for__query_new_mode: db 'ucrtbase._query_new_mode',0

name__realloc_base: db '_realloc_base',0
for__realloc_base: db 'ucrtbase._realloc_base',0

;// expForward _recalloc 'ucrtbase._recalloc'

name__set_new_mode: db '_set_new_mode',0
for__set_new_mode: db 'ucrtbase._set_new_mode',0

;// expForward calloc 'ucrtbase.calloc'
;// expForward free 'ucrtbase.free'
;// expForward malloc 'ucrtbase.malloc'
;// expForward realloc 'ucrtbase.realloc'
%endif ;Palemoon

%ifdef C_MEM_Handlers
name__expand: db '_expand',0
name__msize: db '_msize',0
name__recalloc: db '_recalloc',0
name_calloc: db 'calloc',0
name_free: db 'free',0
name_malloc: db 'malloc',0
name_realloc: db 'realloc',0
%endif ;C_MEM_Handlers
;//
name_MmCreatePool: db 'MmCreatePool',0
name_MmAlloc: db 'MmAlloc',0
name_MmFree: db 'MmFree',0
name_MmReAlloc: db 'MmReAlloc',0
name_MmQuery: db 'MmQuery',0

;// pad to sector boundary:
align 200h, db 0

